comment %

ACPI FACS support routines

%

       	.DOSSEG
        .MODEL  small, c, os_dos

.386

        extern  search:NEAR
        extern  printReg:NEAR
        extern  displayTable:NEAR


        INCLUDE constant.inc
	INCLUDE macros.inc


        .CODE



; entry: esi = pointer to system table
; 
;
facsTableDisplay proc public


        writeln 'Table Signature:'
        mov     cx, 4                           ; 4 bytes signature
@@:	
        mov     dl, gs:[esi]
	mov     ah,2
        int     21h
        inc     esi
   	loop 	@b
        writelnCr ' '


        writeln 'Table Length:'                 ; 4 byte table leng
        mov     eax, gs:[esi]
        mov     cx, 8
        call    printReg
        add     esi, 4
        writelncr ' '

        writeln 'Hardware Signature:'           ; 4 bytes
        mov     eax, gs:[esi]
        mov     cx, 8
        call    printReg
        add     esi, 4
        writelncr ' '

        
        writeln 'Firmware Waking Vector:'        ; 4 bytes
        mov     eax, gs:[esi]
        mov     cx, 8
        call    printReg
        add     esi, 4
        writelncr ' '





        writeln 'Global Lock:' 			; 4 bytes
        mov     eax, gs:[esi]
        mov     edi, eax
        mov     cx, 8
        call    printReg
        add     esi, 4
        writelncr ' '

; flags.

        writeln '                 BIT 0: '
        test    edi, BIT0
        jz      @f

        writelncr 'Pending.'
        jmp     flag1
@@:
        writelncr 'not Pending.'



flag1:
        writeln '                 BIT 1: '
        test    edi, BIT1
        jz      @f

        writelncr 'Owned.'
        jmp     done
@@:
        writelncr 'not Owned.'



done:

        writeln 'Flags:' 			; 4 bytes, offset 20
        mov     eax, gs:[esi]
        mov     edi, eax
        mov     cx, 8
        call    printReg
        add     esi, 4
        writelncr ' '

; flags.

        writeln '                 BIT 0: S4BIOS_REQ '
        test    edi, BIT0
        jz      @f

        writelncr 'supported.'
        jmp     exit
@@:
        writelncr 'not supported.'



exit:
        ret
facsTableDisplay endp






.DATA





End

